using System;
using System.Collections.Generic;
using System.Reflection;
using System.Windows.Forms;

namespace VS_SampleApp
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();

            Assembly[] appAssemblies = System.AppDomain.CurrentDomain.GetAssemblies ();
            foreach (Assembly assembly in appAssemblies )
            {
                foreach (Type t in assembly.GetTypes())
                {
                    Object[] obj = t.GetCustomAttributes(false);
                    if (obj.Length > 0)
                    {
                        if (obj[0].GetType() == typeof(SampleTitleAttribute))
                        {
                            sampleClasses.Add(t);
                        }
                    }
                }
            }
            sampleClasses.Sort(compareSamples);
        }

        private List<Type> sampleClasses = new List<Type>();

        private int compareSamples(Type x, Type y)
        {
            return x.Name.CompareTo(y.Name);
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            foreach (Type t in this.sampleClasses)
            {
                SampleTitleAttribute sna =
                    t.GetCustomAttributes(typeof(SampleTitleAttribute), true)[0] as SampleTitleAttribute;
                cbSelectSample.Items.Add(sna.Name + " (" + t.Name + ")");
            }
            cbSelectSample.SelectedIndex = 0;
        }

        private void btnPerform_Click(object sender, EventArgs e)
        {
            edResult.Clear();
            Type t = this.sampleClasses[cbSelectSample.SelectedIndex];
            SampleBase sample = (SampleBase)Activator.CreateInstance(t);

            sample.Perform();
            edResult.Text = sample.ReportResult();
        }
    }
}